﻿using System;
using HeuristicLab.Algorithms.NSGA3;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace HeuristicLab.Algorithms.NSGA3_3._3.Test
{
    [TestClass]
    public class UtilityTests
    {
        [DataTestMethod]
        [DataRow(0, 1)]
        [DataRow(1, 1)]
        [DataRow(3, 6)]
        [DataRow(4, 24)]
        [DataRow(10, 3628800)]
        [DataRow(12, 479001600)]
        [DataRow(13, 6227020800)]
        [DataRow(14, 87178291200)]
        public void TestFactorial(int input, long result)
        {
            Assert.AreEqual(result, Utility.Factorial(input));
        }

        [DataTestMethod]
        [DataRow(-1)]
        [DataRow(31)]
        public void TestFactorialConstraint(int input)
        {
            Assert.ThrowsException<InvalidOperationException>(() => { Utility.Factorial(input); });
        }

        [DataTestMethod]
        [DataRow(14, 12, 91)]
        public void TestNCR(int n, int r, int result)
        {
            Assert.AreEqual(result, Utility.NCR(n, r));
        }
    }
}